Index: dia/dia-0.86/lib/text.c
diff -u dia/dia-0.86/lib/text.c:1.1.1.1 dia/dia-0.86/lib/text.c:1.2
--- dia/dia-0.86/lib/text.c:1.1.1.1	Tue Aug  8 15:12:15 2000
+++ dia/dia-0.86/lib/text.c	Sat Aug 26 15:39:13 2000
@@ -507,6 +507,11 @@
     } else {
       return;
     }
+#ifdef USE_XIM
+    if(text->line[row][i]<0) {
+      i++;
+    }
+#endif
   }
   text->cursor_pos = text->strlen[row];
 }
@@ -577,11 +582,27 @@
       text_join_lines(text, row);
     return;
   }
+#ifdef USE_XIM
+  if(text->line[row][text->cursor_pos] > 0) {
+    memmove(text->line[row] + text->cursor_pos,
+           text->line[row] + text->cursor_pos + 1,
+           text->strlen[row] - text->cursor_pos);
+
+    text->strlen[row]--;
+  } else {
+    memmove(text->line[row] + text->cursor_pos,
+            text->line[row] + text->cursor_pos + 2,
+            text->strlen[row] - text->cursor_pos - 1);
+
+    text->strlen[row]-=2;
+  }
+#else
   memmove(text->line[row] + text->cursor_pos,
 	  text->line[row] + text->cursor_pos + 1,
 	  text->strlen[row] - text->cursor_pos);
 
   text->strlen[row]--;
+#endif
   
   if (text->cursor_pos > text->strlen[text->cursor_row])
     text->cursor_pos = text->strlen[text->cursor_row];
@@ -608,6 +629,22 @@
       text_join_lines(text, row-1);
     return;
   }
+#ifdef USE_XIM
+  if(text->line[row][text->cursor_pos-1] > 0) {
+    memmove(text->line[row] + text->cursor_pos - 1,
+            text->line[row] + text->cursor_pos,
+            text->strlen[row] - text->cursor_pos + 1);
+    text->strlen[row]--;
+    
+    text->cursor_pos --;
+  } else {
+    memmove(text->line[row] + text->cursor_pos - 2,
+            text->line[row] + text->cursor_pos,
+            text->strlen[row] - text->cursor_pos + 2);
+    text->strlen[row]-=2;
+    text->cursor_pos -=2;
+  }
+#else
   memmove(text->line[row] + text->cursor_pos - 1,
 	  text->line[row] + text->cursor_pos,
 	  text->strlen[row] - text->cursor_pos + 1);
@@ -615,6 +652,7 @@
   text->strlen[row]--;
 
   text->cursor_pos --;
+#endif
   
   if (text->cursor_pos > text->strlen[text->cursor_row])
     text->cursor_pos = text->strlen[text->cursor_row];
@@ -738,6 +776,18 @@
     if (text->cursor_pos > text->strlen[text->cursor_row])
       text->cursor_pos = text->strlen[text->cursor_row];
 
+#ifdef USE_XIM
+    {
+      int i = 0;
+      while(i < text->cursor_pos) {
+	if ( text->line[text->cursor_row][i] < 0 )
+	  i+=2;
+	else
+	  i++;
+      }
+      text->cursor_pos = i;
+    }
+#endif
     break;
   case GDK_Down:
     text->cursor_row++;
@@ -747,14 +797,42 @@
     if (text->cursor_pos > text->strlen[text->cursor_row])
       text->cursor_pos = text->strlen[text->cursor_row];
     
+#ifdef USE_XIM
+    {
+      int i = 0;
+      while(i < text->cursor_pos) {
+	if ( text->line[text->cursor_row][i] < 0 )
+	  i+=2;
+	else
+	  i++;
+      }
+      text->cursor_pos = i;
+    }
+#endif
     break;
   case GDK_Left:
+#ifdef USE_XIM
+    if(text->line[text->cursor_row][text->cursor_pos-1] > 0) {
+      text->cursor_pos--;
+    } else {
+      text->cursor_pos-=2;
+    }
+#else
     text->cursor_pos--;
+#endif
     if (text->cursor_pos<0)
       text->cursor_pos = 0;
     break;
   case GDK_Right:
+#ifdef USE_XIM
+    if(text->line[text->cursor_row][text->cursor_pos+1] > 0) {
+      text->cursor_pos++;
+    } else {
+      text->cursor_pos+=2;
+    }
+#else
     text->cursor_pos++;
+#endif
     if (text->cursor_pos > text->strlen[text->cursor_row])
       text->cursor_pos = text->strlen[text->cursor_row];
     break;
